# File: downcalibfilegen.py
# Company: Modal-AI
# Author: Rich Martin (rich@modalai.com)
# Description: Generates a SNAV downward VIO camera calibration XML file using  
# fisheye calibration YAML files generated by the ROS calibration tool.

import numpy as np
import sys
import argparse
import decimal
import os.path
import yaml
import xml.etree.ElementTree as et


#coverts float to string without scientific notation
def float_to_str(val):
    ctx = decimal.Context()
    ctx.prec = 15
    dec = ctx.create_decimal(repr(val))

    return format(dec, 'f')


print("Generating SNAV downward camera calibration . . . ")

yaml_default  = "/tmp/calibrationdata/ost.yaml";
xml_snav_default   = "calibration.downward.xml";

parser = argparse.ArgumentParser(description='Generate SNAV Stereo Calibration File')
parser.add_argument('-y','--yaml', dest='yaml_file', action='store',
                     default=yaml_default,   
                     help = "ROS downward camera calibration YAML file.") 

parser.add_argument('-x', '--xml_SNAV', dest='snav_xml_file', action='store',
                     default=xml_snav_default,
                    help  = "SNAV downward camera calibration template XML file.")
args = parser.parse_args()

#check if files exist before continuing
if not os.path.isfile(args.snav_xml_file):
  sys.exit(args.snav_xml_file + " file not found.");
elif not os.path.isfile(args.yaml_file):
  sys.exit(args.yaml_file + " file not found.");
  

#read SNAV calibration XML file
calib = et.parse(args.snav_xml_file)
root  = calib.getroot()

#Read YAML calibration files
with open(args.yaml_file, 'r') as ymlfile:
  try:
    down_calib = yaml.load(ymlfile) 
  except yaml.YAMLError as exc:
    sys.exit(exc)

#download camera
img_w = down_calib['image_width']
img_h = down_calib['image_height'] 
K = down_calib['camera_matrix']['data']
D = down_calib['distortion_coefficients']['data']
P = np.array(down_calib['projection_matrix']['data'])
R = np.array(down_calib['rectification_matrix']['data'])

#parameter substitutions and calcuations originate from the following repository (lines 107 - 177):
#https://github.com/ATLFlight/dfs-ros-example/blob/master/src/nodes/SnapdragonDfsRos.cpp

#downward camera parameters
#set principal points
prin_pt_X = K[2]
prin_pt_Y = K[5]
#set focal lengths
foc_len_X = K[0]
foc_len_Y = K[4]
#set distortion coefficients
distort_coeffs = D

#Downward camera parameters
print("Downward Image Width: ", img_w)
print("Downward Image Height: ", img_h)
print("Downward Principal Point X:", prin_pt_X)
print("Downward Principal Point Y:", prin_pt_Y)
print("Downward Focal Length X:",    foc_len_X)
print("Downward Focal Length Y:",    foc_len_Y)
print("Downward Distortion Ceoffs:", distort_coeffs)


#XML Parameters
#set left camera parameters
root.find("./SnavCalibrationDownward/param[@name='calib_pixel_width']").attrib["value"] = str(img_w)
root.find("./SnavCalibrationDownward/param[@name='calib_pixel_height']").attrib["value"] = str(img_h)

root.find("./SnavCalibrationDownward/param[@name='principal_point_x']").attrib["value"] = float_to_str(prin_pt_X)
root.find("./SnavCalibrationDownward/param[@name='principal_point_y']").attrib["value"] = float_to_str(prin_pt_Y)

root.find("./SnavCalibrationDownward/param[@name='focal_length_x']").attrib["value"] = float_to_str(foc_len_X)
root.find("./SnavCalibrationDownward/param[@name='focal_length_y']").attrib["value"] = float_to_str(foc_len_Y)

root.find("./SnavCalibrationDownward/param[@name='distortion_0']").attrib["value"] = float_to_str(distort_coeffs[0])
root.find("./SnavCalibrationDownward/param[@name='distortion_1']").attrib["value"] = float_to_str(distort_coeffs[1])
root.find("./SnavCalibrationDownward/param[@name='distortion_2']").attrib["value"] = float_to_str(distort_coeffs[2])
root.find("./SnavCalibrationDownward/param[@name='distortion_3']").attrib["value"] = float_to_str(distort_coeffs[3])

#write XML file
calib.write(args.snav_xml_file)

